## lakeFS Playground

Experience lakeFS first hand with your own isolated environment.
You can easily integrate it with your existing tools, and feel lakeFS in action in an environment
similar to your own.

<p>
    <a class="btn btn-green" href="https://demo.lakefs.io/" target="_blank">
        Try lakeFS now without installing
    </a>
</p>

## Katacoda Tutorial

Learn how to use lakeFS using the CLI and an interactive Spark shell - all from your browser, without installing anything.

In the tutorial we cover:

- Basic `lakectl` command line usage
- How to read, write, list and delete objects from lakeFS using the `lakectl` command
- Read from, and write to lakeFS using its S3 API interface using [Spark](https://spark.apache.org/){: target="_blank" }
- Diff, commit and merge the changes created by Spark
- Track commit history to understand changes to your data over time

The web based environment provides a full working lakeFS and Spark environment, so feel free to explore it on your own.

<p>
    <a class="btn btn-green" href="https://www.katacoda.com/lakefs/scenarios/lakefs-play" target="_blank">
        Start Katacoda Tutorial Now
    </a>
</p>

## Next Steps

After getting acquainted with lakeFS, easily [install it on your computer](installing.html) or [deploy it on your cloud account](../deploy/index.html).
